=== books/projects/filesystems/test/Makefile ===
# test-stat-replicant-1 and test-stat-replicant-2 are left out from
# this list for reasons explained in a comment below.
TEST:= test-cp-replicant-1 test-cp-replicant-2 test-cp-replicant-3 \
test-cp-replicant-4 mtools-test-cp-replicant-2 \
test-mkfs-replicant-1 test-mkfs-replicant-2 \
test-wc-replicant-1 test-wc-replicant-2 test-wc-replicant-3 \
test-rm-replicant-1 test-rm-replicant-2 test-rm-replicant-3 \
test-rm-replicant-4 mtools-test-rm-replicant-1 \
mtools-test-rm-replicant-2 \
test-unlink-replicant-1 test-unlink-replicant-2 \
test-unlink-replicant-3 \
test-mkdir-replicant-1 test-mkdir-replicant-2 \
mtools-test-mkdir-replicant-1 \
test-rmdir-replicant-1 test-rmdir-replicant-2 \
mtools-test-rmdir-replicant-1 \
test-mv-replicant-1 mtools-test-mv-replicant-1 \
mtools-test-mv-replicant-2

test: $(TEST)

.PHONY: clean-mountpoint test $(TEST)

.PHONY: debug-create-dir-and-file debug-create-dir debug-do-nothing \
debug-create-dir-copy-file

.PHONY: mtools-read-write-test-128MB \
mtools-read-write-test-256MB \
mtools-read-write-test-512MB mtools-read-write-test-1024MB

# FUSEPOINT and BBFS are commented below because they refer to Joseph
# Pfeiffer's pedagogical Big Brother Filesystem, which I used in some
# of the tests. For almost every test, they only helped log the
# syscalls and their return values without affecting the course of the
# test; however, the stat tests test-stat-replicant-1 and
# test-stat-replicant-2 do rely on them. Without the interposition of
# the FUSE layer, the id value in the struct statfs can be completely
# arbitrary depending on mount time details which our stat
# implementation has no access to, but when FUSE is interposed, a 0
# value is assigned to id. This value is hard-coded in the stat
# tests; they can be run by downloading and compiling BBFS
# (https://www.cs.nmsu.edu/~pfeiffer/fuse-tutorial/) and noting the
# path to the executable in the BBFS variable, below.
DISK=disk1.raw
SIZE=70000
MOUNTPOINT=mount1
# FUSEPOINT=mount2
# BBFS=$(HOME)/src/bbfs/fuse-tutorial-2018-02-04/src/bbfs
UID=$(shell id -u)
GID=$(shell id -g)
MTOOLSRC=$(shell pwd)/.mtoolsrc

clean-mountpoint:
	rm -rf $(MOUNTPOINT)

$(MOUNTPOINT):
	rm -rf $(MOUNTPOINT)
	mkdir -p $(MOUNTPOINT)

# $(FUSEPOINT):
# 	rm -rf $(FUSEPOINT)
# 	mkdir -p $(FUSEPOINT)

test-cp-replicant-1: cp-ref-output-1.txt cp-output-1.txt
	diff -u -i cp-ref-output-1.txt cp-output-1.txt

test-cp-replicant-2: cp-ref-output-2.txt cp-output-2.txt
	diff -u -i cp-ref-output-2.txt cp-output-2.txt

test-cp-replicant-3: cp-ref-output-3.txt cp-output-3.txt
	diff -u -i cp-ref-output-3.txt cp-output-3.txt

test-cp-replicant-4: cp-ref-output-4.txt cp-output-4.txt
	diff -u -i cp-ref-output-4.txt cp-output-4.txt

mtools-test-cp-replicant-2: mtools-cp-ref-output-2.txt mtools-cp-output-2.txt
	diff -u -i mtools-cp-ref-output-2.txt mtools-cp-output-2.txt

test-cp-replicant-5: cp-ref-output-5.txt cp-output-5.txt
	diff -u -i cp-ref-output-5.txt cp-output-5.txt

test-mkfs-replicant-1: mkfs-ref-output-1.txt mkfs-output-1.txt
	diff -u -i mkfs-ref-output-1.txt mkfs-output-1.txt

test-mkfs-replicant-2: mkfs-ref-output-2.txt mkfs-output-2.txt
	diff -u -i mkfs-ref-output-2.txt mkfs-output-2.txt

test-mkfs-replicant-3: mkfs-ref-output-3.txt mkfs-output-3.txt
	diff -u -i mkfs-ref-output-3.txt mkfs-output-3.txt

test-wc-replicant-1: wc-ref-output-1.txt wc-output-1.txt
	diff -u -i wc-ref-output-1.txt wc-output-1.txt

test-wc-replicant-2: wc-ref-output-2.txt wc-output-2.txt
	diff -u -i wc-ref-output-2.txt wc-output-2.txt

test-wc-replicant-3: wc-ref-output-3.txt wc-output-3.txt
	diff -u -i wc-ref-output-3.txt wc-output-3.txt

test-stat-replicant-1: stat-ref-output-1.txt stat-output-1.txt
	diff -u -i stat-ref-output-1.txt stat-output-1.txt

test-stat-replicant-2: stat-ref-output-2.txt stat-output-2.txt
	diff -u -i stat-ref-output-2.txt stat-output-2.txt

test-rm-replicant-1: rm-output-1.raw rm-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-1.raw" \
	INPUT="rm-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-rm-replicant-2: rm-output-2.raw rm-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-2.raw" \
	INPUT="rm-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-rm-replicant-3: rm-output-3.raw rm-ref-output-3.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-3.raw" \
	INPUT="rm-output-3.raw" $(ACL2) -- < compare-disks.lisp

test-rm-replicant-4: rm-output-4.raw rm-ref-output-4.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-4.raw" \
	INPUT="rm-output-4.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rm-replicant-1: mtools-rm-ref-output-1.raw mtools-rm-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-rm-ref-output-1.raw" \
	INPUT="mtools-rm-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rm-replicant-2: mtools-rm-ref-output-2.raw mtools-rm-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-rm-ref-output-2.raw" \
	INPUT="mtools-rm-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-unlink-replicant-1: unlink-output-1.raw unlink-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="unlink-ref-output-1.raw" \
	INPUT="unlink-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-unlink-replicant-2: unlink-output-2.raw unlink-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="unlink-ref-output-2.raw" \
	INPUT="unlink-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-unlink-replicant-3: unlink-output-3.raw unlink-ref-output-3.raw
	env DISK=$(DISK) REF_INPUT="unlink-ref-output-3.raw" \
	INPUT="unlink-output-3.raw" $(ACL2) -- < compare-disks.lisp

test-mkdir-replicant-1: mkdir-output-1.raw mkdir-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="mkdir-ref-output-1.raw" \
	INPUT="mkdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-mkdir-replicant-2: mkdir-output-2.raw mkdir-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="mkdir-ref-output-2.raw" \
	INPUT="mkdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mkdir-replicant-1: mtools-mkdir-ref-output-1.raw mtools-mkdir-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-mkdir-ref-output-1.raw" \
	INPUT="mtools-mkdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mkdir-replicant-2: mtools-mkdir-ref-output-2.raw mtools-mkdir-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-mkdir-ref-output-2.raw" \
	INPUT="mtools-mkdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-rmdir-replicant-1: rmdir-output-1.raw rmdir-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="rmdir-ref-output-1.raw" \
	INPUT="rmdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-rmdir-replicant-2: rmdir-output-2.raw rmdir-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="rmdir-ref-output-2.raw" \
	INPUT="rmdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rmdir-replicant-1: mtools-rmdir-ref-output-1.raw mtools-rmdir-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-rmdir-ref-output-1.raw" \
	INPUT="mtools-rmdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rmdir-replicant-2: mtools-rmdir-ref-output-2.raw mtools-rmdir-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-rmdir-ref-output-2.raw" \
	INPUT="mtools-rmdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-mv-replicant-1: mv-output-1.raw mv-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="mv-ref-output-1.raw" \
	INPUT="mv-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mv-replicant-1: mtools-mv-output-1.raw mtools-mv-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-mv-ref-output-1.raw" \
	INPUT="mtools-mv-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mv-replicant-2: mtools-mv-ref-output-2.raw mtools-mv-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-mv-ref-output-2.raw" \
	INPUT="mtools-mv-output-2.raw" $(ACL2) -- < compare-disks.lisp

cp-ref-output-1.txt cp-output-1.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	echo "four" > $(MOUNTPOINT)/vmlinuz
	cat $(MOUNTPOINT)/vmlinuz > cp-ref-output-1.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-1.txt" \
	CP_INPUT="/vmlinuz" $(ACL2) < cp-replicant.lisp

cp-ref-output-2.txt cp-output-2.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt $(MOUNTPOINT)/vmlinuz
	cat $(MOUNTPOINT)/vmlinuz > cp-ref-output-2.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-2.txt" \
	CP_INPUT="/vmlinuz" $(ACL2) < cp-replicant.lisp

cp-ref-output-3.txt cp-output-3.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt $(MOUNTPOINT)/vmlinuz
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	cat $(MOUNTPOINT)/initrd.img > cp-ref-output-3.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-3.txt" \
	CP_INPUT="/initrd.img" $(ACL2) < cp-replicant.lisp

cp-ref-output-4.txt cp-output-4.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	for i1 in $(shell seq 1 32); do \
		cp input-1204-bytes.txt $(MOUNTPOINT)/initrd$$i1.img; \
	done
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	cat $(MOUNTPOINT)/initrd.img > cp-ref-output-4.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-4.txt" \
	CP_INPUT="/initrd.img" $(ACL2) < cp-replicant.lisp

cp-ref-output-5.txt cp-output-5.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt $(MOUNTPOINT)/initrd.img
	sync $(MOUNTPOINT)/initrd.img
	rm $(MOUNTPOINT)/initrd.img
	for i1 in $(shell seq 1 32); do \
		cp input-1204-bytes.txt $(MOUNTPOINT)/initrd$$i1.img; \
	done
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	cat $(MOUNTPOINT)/initrd.img > cp-ref-output-5.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-5.txt" \
	CP_INPUT="/initrd.img" $(ACL2) < cp-replicant.lisp

mtools-cp-ref-output-2.txt mtools-cp-output-2.txt: cp-replicant.lisp
	rm -f $(DISK) mtools-cp-ref-output-2.txt
	dd if=/dev/zero of=$(DISK) bs=4096 count=17920
	env MTOOLSRC=$(MTOOLSRC) mformat -T 140000 -h 64 -s 32 -S \
	2 -F -c 2 c:
	env MTOOLSRC=$(MTOOLSRC) mcopy input-1204-bytes.txt c:/vmlinuz
	env MTOOLSRC=$(MTOOLSRC) mcopy c:/vmlinuz mtools-cp-ref-output-2.txt
	env DISK=$(DISK) CP_OUTPUT="mtools-cp-output-2.txt" \
	CP_INPUT="/vmlinuz" $(ACL2) < cp-replicant.lisp

mkfs-ref-output-1.txt mkfs-output-1.txt: $(MOUNTPOINT) \
mkfs.fat-3.0.28-replicant.lisp
	rm -f $(DISK)
	(mkfs.fat -C -v -F 32 -s 1 $(DISK) $(SIZE)) > mkfs-ref-output-1.txt
	env DISK=$(DISK) MKFS_OUTPUT="mkfs-output-1.txt" $(ACL2) < \
	mkfs.fat-3.0.28-replicant.lisp

mkfs-ref-output-2.txt mkfs-output-2.txt: $(MOUNTPOINT) \
mkfs.fat-3.0.28-replicant.lisp
	rm -f $(DISK)
	(mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)) > mkfs-ref-output-2.txt
	env DISK=$(DISK) MKFS_OUTPUT="mkfs-output-2.txt" $(ACL2) < \
	mkfs.fat-3.0.28-replicant.lisp

wc-ref-output-1.txt wc-output-1.txt: $(MOUNTPOINT) wc-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	wc -c < $(MOUNTPOINT)/initrd.img > wc-ref-output-1.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) WC_OUTPUT="wc-output-1.txt" \
	WC_INPUT="/initrd.img" $(ACL2) -- -c < wc-replicant.lisp

wc-ref-output-2.txt wc-output-2.txt: $(MOUNTPOINT) wc-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	wc -l < $(MOUNTPOINT)/initrd.img > wc-ref-output-2.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
