=== books/workshops/2003/kaufmann/support/Makefile ===
DIRS = input rtl/tool rtl
include ../../../../Makefile-subdirs
