=== debian/changelog ===
acl2 (8.2dfsg-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:09:23 +0100

acl2 (8.2dfsg-3) unstable; urgency=medium

  * revert -2, set *split-files* to 100000 instead

 -- Camm Maguire <camm@debian.org>  Fri, 27 Dec 2019 15:15:44 +0000

acl2 (8.2dfsg-2) unstable; urgency=medium

  * Temporarily set GCL_MEM_MULTIPLE to 0.75 in saved_acl2 build to
    workaround gcc oom issues

 -- Camm Maguire <camm@debian.org>  Thu, 26 Dec 2019 20:47:09 +0000

acl2 (8.2dfsg-1) unstable; urgency=medium

  * New upstream release
  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 19 Dec 2019 15:30:07 +0000

acl2 (8.1dfsg-6) unstable; urgency=medium

  * build-dep gcl ( >= 2.6.12-90)
  * latest standards

 -- Camm Maguire <camm@debian.org>  Mon, 09 Dec 2019 14:21:30 +0000

acl2 (8.1dfsg-5) unstable; urgency=medium

  * build-dep gcl ( >= 2.6.12-89)
  * Bug fix: "acl2 - FTBFS on ppc64el - invalid Unknown reloc type 31",
    thanks to thierry.fauck@fr.ibm.com</a>; (Closes: #944222).

 -- Camm Maguire <camm@debian.org>  Sun, 08 Dec 2019 15:13:52 +0000

acl2 (8.1dfsg-4) unstable; urgency=medium

  * source-only upload
  * Bug fix: "Build-Depends on emacs25 which has been removed from
    unstable/bullseye", thanks to Paul Gevers (Closes: #941641).

 -- Camm Maguire <camm@debian.org>  Thu, 31 Oct 2019 17:17:49 +0000
